/***************************************************************************
                          maptile_ladder.cpp  -  description
                             -------------------
    begin                : Mon Feb 25 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "maptile_ladder.h"
#include "resources.h"
#include "map.h"
#include "map_sample.h"
#include "game.h"

Maptile_ladder::Maptile_ladder(int _x, int _y, bool _hidden, WorldType _wt, Map* _map) : Maptile(_x, _y, _wt, _map)
{
	blocking=false;
	fallt=false;

	if(_hidden==false)
	mt=LADDER;
	else
	{
		mt=EMPTY;
		fallt=true;
	}
	spr=42;

	sur=Resources::Tiles();

	hidden=_hidden;
}
Maptile_ladder::~Maptile_ladder(){
}
void Maptile_ladder::show()
{
	if(!hidden)
	sur->put_screen(x, y, spr);
}
void Maptile_ladder::act()
{
	if(map->game->sample->no_gold())
	{
		mt=LADDER;
		blocking=false;
		hidden=false;
		fallt=false;
	}
}