/***************************************************************************
                          resources.cpp  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "resources.h"
#include "ClanLib/vorbis.h"

CL_Surface* Resources::auriferous=0;
CL_Surface* Resources::net=0;
CL_Surface* Resources::effectbar=0;
CL_Surface* Resources::greenframe=0;
CL_Surface* Resources::mmeffect=0;
CL_Surface* Resources::scroller=0;
CL_Surface* Resources::background=0;
CL_Surface* Resources::checker=0;
CL_Surface* Resources::arrows=0;
CL_Surface* Resources::funthing=0;

CL_MouseCursorProvider* Resources::cursor=0;

CL_Surface* Resources::gameframe=0;
CL_Surface* Resources::gas=0;
CL_Surface* Resources::tiles=0;
CL_Surface* Resources::player=0;
CL_Surface* Resources::playerr=0;
CL_Surface* Resources::monk=0;
CL_Surface* Resources::explosion=0;
CL_Surface* Resources::atile=0;
CL_Surface* Resources::abackground=0;
CL_Surface* Resources::itile=0;	
CL_Surface* Resources::ibackground=0;
CL_Surface* Resources::ltile=0;
CL_Surface* Resources::lbackground=0;
CL_Surface* Resources::jtile=0;	
CL_Surface* Resources::jbackground=0;
CL_Surface* Resources::ttile=0;	
CL_Surface* Resources::tbackground=0;
CL_Font* Resources::rfontg=0;
CL_Font* Resources::rfonta=0;
CL_Font* Resources::rfont=0;
CL_Font* Resources::gfont=0;
CL_Font* Resources::cgfont=0;
CL_SoundBuffer* Resources::accrue=0;
CL_SoundBuffer* Resources::befudlementgas=0;
CL_SoundBuffer* Resources::bomblit=0;
CL_SoundBuffer* Resources::born=0;
CL_SoundBuffer* Resources::burndown=0;
CL_SoundBuffer* Resources::cbexplode=0;
CL_SoundBuffer* Resources::ceexplode=0;
CL_SoundBuffer* Resources::chput=0;
CL_SoundBuffer* Resources::clickcancel=0;
CL_SoundBuffer* Resources::clicknormal=0;
CL_SoundBuffer* Resources::clickok=0;
CL_SoundBuffer* Resources::did=0;
CL_SoundBuffer* Resources::die=0;
CL_SoundBuffer* Resources::digoff=0;
CL_SoundBuffer* Resources::doorunlock=0;
CL_SoundBuffer* Resources::explode=0;
CL_SoundBuffer* Resources::explode1=0;
CL_SoundBuffer* Resources::explode2=0;
CL_SoundBuffer* Resources::fallwater=0;
CL_SoundBuffer* Resources::finish=0;
CL_SoundBuffer* Resources::gold=0;
CL_SoundBuffer* Resources::lasertripmine=0;
CL_SoundBuffer* Resources::levelready=0;
CL_SoundBuffer* Resources::life=0;
CL_SoundBuffer* Resources::pickup=0;
CL_SoundBuffer* Resources::putaway=0;
CL_SoundBuffer* Resources::slime=0;
CL_SoundBuffer* Resources::speed=0;
CL_SoundBuffer* Resources::teleport=0;
CL_SoundBuffer* Resources::tnt=0;
CL_SoundBuffer* Resources::trap=0;
CL_SoundBuffer_Session* Resources::jungle=0;
CL_SoundBuffer_Session* Resources::aqua=0;
CL_SoundBuffer_Session* Resources::lava=0;
CL_SoundBuffer_Session* Resources::ice=0;
CL_SoundBuffer_Session* Resources::tech=0;

CL_ResourceManager * Resources::res=0;
CL_String Resources::datapath=0;

CL_Surface* Resources::Auriferous()
{
	if(!auriferous)
	auriferous=CL_Surface::load("menu/auriferous", res);
	return auriferous;
}
CL_Surface* Resources::Net()
{
	if(!net)
	net=CL_Surface::load("menu/net", res);
	return net;
}
CL_Surface* Resources::Effectbar()
{
	if(!effectbar)
	effectbar=CL_Surface::load("menu/effectbar", res);
	return effectbar;
}
CL_Surface* Resources::Greenframe()
{
	if(!greenframe)
	greenframe=CL_Surface::load("menu/greenframe", res);
	return greenframe;
}
CL_Surface* Resources::Mmeffect()
{
	if(!mmeffect)
	mmeffect=CL_Surface::load("menu/mmeffect", res);
	return mmeffect;
}
CL_Surface* Resources::Scroller()
{
	if(!scroller)
	scroller=CL_Surface::load("menu/scroller", res);
	return scroller;
}
CL_Surface* Resources::Background()
{
	if(!background)
	background=CL_Surface::load("menu/background", res);
	return background;
}
CL_Surface* Resources::Checker()
{
	if(!checker)
	checker=CL_Surface::load("menu/checker", res);
	return checker;
}
CL_Surface* Resources::Arrows()
{
	if(!arrows)
	arrows=CL_Surface::load("menu/arrows", res);
	return arrows;
}
CL_Surface* Resources::Funthing()
{
	if(!funthing)
	funthing=CL_Surface::load("menu/funthing", res);
	return funthing;
}
CL_MouseCursorProvider* Resources::Cursor()
{
	if(!cursor)
	cursor=CL_MouseCursorProvider::load("menu/cursor", res);
	return cursor;
}
CL_Surface* Resources::Gameframe()
{
	if(!gameframe)
	gameframe=CL_Surface::load("menu/gameframe", res);
	return gameframe;
}
CL_Surface* Resources::Tiles()
{
	if(!tiles)
	tiles=CL_Surface::load("game/tiles", res);
	return tiles;
}
CL_Surface* Resources::Gas()
{
	if(!gas)
	gas=CL_Surface::load("game/gas", res);
	return gas;
}
CL_Surface* Resources::Player()
{
	if(!player)
	player=CL_Surface::load("game/player", res);
	return player;
}
CL_Surface* Resources::Playerr()
{
	if(!playerr)
	playerr=CL_Surface::load("game/playerr", res);
	return playerr;
}
CL_Surface* Resources::Monk()
{
	if(!monk)
	monk=CL_Surface::load("game/monk", res);
	return monk;
}
CL_Surface* Resources::Explosion()
{
	if(!explosion)
	explosion=CL_Surface::load("game/explosion", res);
	return explosion;
}
CL_Surface* Resources::Atile()
{
	if(!atile)
	atile=CL_Surface::load("game/atile", res);
	return atile;
}
CL_Surface* Resources::Abackground()
{
	if(!abackground)
	abackground=CL_Surface::load("game/abackground", res);
	return abackground;
}
CL_Surface* Resources::Itile()
{
	if(!itile)
	itile=CL_Surface::load("game/itile", res);
	return itile;
}
CL_Surface* Resources::Ibackground()
{
	if(!ibackground)
	ibackground=CL_Surface::load("game/ibackground", res);
	return ibackground;
}
CL_Surface* Resources::Ltile()
{
	if(!ltile)
	ltile=CL_Surface::load("game/ltile", res);
	return ltile;
}
CL_Surface* Resources::Lbackground()
{
	if(!lbackground)
	lbackground=CL_Surface::load("game/lbackground", res);
	return lbackground;
}
CL_Surface* Resources::Jtile()
{
	if(!jtile)
	jtile=CL_Surface::load("game/jtile", res);
	return jtile;
}
CL_Surface* Resources::Jbackground()
{
	if(!jbackground)
	jbackground=CL_Surface::load("game/jbackground", res);
	return jbackground;
}
CL_Surface* Resources::Ttile()
{
	if(!ttile)
	ttile=CL_Surface::load("game/ttile", res);
	return ttile;
}
CL_Surface* Resources::Tbackground()
{
	if(!tbackground)
	tbackground=CL_Surface::load("game/tbackground", res);
	return tbackground;
}
CL_Font* Resources::Rfontg()
{
	if(!rfontg)
	rfontg=CL_Font::load("menu/rfontg", res);
	return rfontg;
}
CL_Font* Resources::Rfonta()
{
	if(!rfonta)
	rfonta=CL_Font::load("menu/rfonta", res);
	return rfonta;
}
CL_Font* Resources::Rfont()
{
	if(!rfont)
	rfont=CL_Font::load("menu/rfont", res);
	return rfont;
}
CL_Font* Resources::Gfont()
{
	if(!gfont)
	gfont=CL_Font::load("menu/gfont", res);
	return gfont;
}
CL_Font* Resources::Cgfont()
{
	if(!cgfont)
	cgfont=CL_Font::load("menu/cgfont", res);
	return cgfont;
}
CL_SoundBuffer* Resources::Accrue()
{
	if(!accrue)
	accrue=CL_SoundBuffer::load("sound/accrue", res);
	return accrue;
}
CL_SoundBuffer* Resources::Befudlementgas()
{
	if(!befudlementgas)
	befudlementgas=CL_SoundBuffer::load("sound/befudlementgas", res);
	return befudlementgas;
}
CL_SoundBuffer* Resources::Bomblit()
{
	if(!bomblit)
	bomblit=CL_SoundBuffer::load("sound/bomblit", res);
	return bomblit;
}
CL_SoundBuffer* Resources::Born()
{
	if(!born)
	born=CL_SoundBuffer::load("sound/born", res);
	return born;
}
CL_SoundBuffer* Resources::Burndown()
{
	if(!burndown)
	burndown=CL_SoundBuffer::load("sound/burndown", res);
	return burndown;
}
CL_SoundBuffer* Resources::Cbexplode()
{
	if(!cbexplode)
	cbexplode=CL_SoundBuffer::load("sound/cbexplode", res);
	return cbexplode;
}
CL_SoundBuffer* Resources::Ceexplode()
{
	if(!ceexplode)
	ceexplode=CL_SoundBuffer::load("sound/ceexplode", res);
	return ceexplode;
}
CL_SoundBuffer* Resources::Chput()
{
	if(!chput)
	chput=CL_SoundBuffer::load("sound/chput", res);
	return chput;
}
CL_SoundBuffer* Resources::Clickcancel()
{
	if(!clickcancel)
	clickcancel=CL_SoundBuffer::load("sound/clickcancel", res);
	return clickcancel;
}
CL_SoundBuffer* Resources::Clicknormal()
{
	if(!clicknormal)
	clicknormal=CL_SoundBuffer::load("sound/clicknormal", res);
	return clicknormal;
}
CL_SoundBuffer* Resources::Clickok()
{
	if(!clickok)
	clickok=CL_SoundBuffer::load("sound/clickok", res);
	return clickok;
}
CL_SoundBuffer* Resources::Did()
{
	if(!did)
	did=CL_SoundBuffer::load("sound/did", res);
	return did;
}
CL_SoundBuffer* Resources::Die()
{
	if(!die)
	die=CL_SoundBuffer::load("sound/die", res);
	return die;
}
CL_SoundBuffer* Resources::Digoff()
{
	if(!digoff)
	digoff=CL_SoundBuffer::load("sound/digoff", res);
	return digoff;
}
CL_SoundBuffer* Resources::Doorunlock()
{
	if(!doorunlock)
	doorunlock=CL_SoundBuffer::load("sound/doorunlock", res);
	return doorunlock;
}
CL_SoundBuffer* Resources::Explode()
{
	if(!explode)
	explode=CL_SoundBuffer::load("sound/explode", res);
	return explode;
}
CL_SoundBuffer* Resources::Explode1()
{
	if(!explode1)
	explode1=CL_SoundBuffer::load("sound/explode1", res);
	return explode1;
}
CL_SoundBuffer* Resources::Explode2()
{
	if(!explode2)
	explode2=CL_SoundBuffer::load("sound/explode2", res);
	return explode2;
}
CL_SoundBuffer* Resources::Fallwater()
{
	if(!fallwater)
	fallwater=CL_SoundBuffer::load("sound/fallwater", res);
	return fallwater;
}
CL_SoundBuffer* Resources::Finish()
{
	if(!finish)
	finish=CL_SoundBuffer::load("sound/finish", res);
	return finish;
}
CL_SoundBuffer* Resources::Gold()
{
	if(!gold)
	gold=CL_SoundBuffer::load("sound/gold", res);
	return gold;
}
CL_SoundBuffer* Resources::Lasertripmine()
{
	if(!lasertripmine)
	lasertripmine=CL_SoundBuffer::load("sound/lasertripmine", res);
	return lasertripmine;
}
CL_SoundBuffer* Resources::Levelready()
{
	if(!levelready)
	levelready=CL_SoundBuffer::load("sound/levelready", res);
	return levelready;
}
CL_SoundBuffer* Resources::Life()
{
	if(!life)
	life=CL_SoundBuffer::load("sound/life", res);
	return life;
}
CL_SoundBuffer* Resources::Pickup()
{
	if(!pickup)
	pickup=CL_SoundBuffer::load("sound/pickup", res);
	return pickup;
}
CL_SoundBuffer* Resources::Putaway()
{
	if(!putaway)
	putaway=CL_SoundBuffer::load("sound/putaway", res);
	return putaway;
}
CL_SoundBuffer* Resources::Slime()
{
	if(!slime)
	slime=CL_SoundBuffer::load("sound/slime", res);
	return slime;
}
CL_SoundBuffer* Resources::Speed()
{
	if(!speed)
	speed=CL_SoundBuffer::load("sound/speed", res);
	return speed;
}
CL_SoundBuffer* Resources::Teleport()
{
	if(!teleport)
	teleport=CL_SoundBuffer::load("sound/teleport", res);
	return teleport;
}
CL_SoundBuffer* Resources::Tnt()
{
	if(!tnt)
	tnt=CL_SoundBuffer::load("sound/tnt", res);
	return tnt;
}
CL_SoundBuffer* Resources::Trap()
{
	if(!trap)
	trap=CL_SoundBuffer::load("sound/trap", res);
	return trap;
}
CL_SoundBuffer_Session* Resources::Jungle()
{
	if(!jungle)
	{
    CL_SoundBuffer *sample= new CL_SoundBuffer(new CL_VorbisSoundProvider("music/jungle.ogg", res), true);
    jungle = new CL_SoundBuffer_Session(sample->prepare());
    //jungle->set_looping(true);
  }
	return jungle;
}
CL_SoundBuffer_Session* Resources::Tech()
{
	if(!tech)
	{
    CL_SoundBuffer *sample= new CL_SoundBuffer(new CL_VorbisSoundProvider("music/tech.ogg", res), true);
    tech = new CL_SoundBuffer_Session(sample->prepare());
    //tech->set_looping(true);
  }
	return tech;
}
CL_SoundBuffer_Session* Resources::Lava()
{
	if(!lava)
	{
    CL_SoundBuffer *sample= new CL_SoundBuffer(new CL_VorbisSoundProvider("music/lava.ogg", res), true);
    lava = new CL_SoundBuffer_Session(sample->prepare());
    //lava->set_looping(true);
  }
	return lava;
}
CL_SoundBuffer_Session* Resources::Ice()
{
	if(!ice)
	{
    CL_SoundBuffer *sample= new CL_SoundBuffer(new CL_VorbisSoundProvider("music/ice.ogg", res), true);
    ice = new CL_SoundBuffer_Session(sample->prepare());
    //ice->set_looping(true);
  }
	return ice;
}
CL_SoundBuffer_Session* Resources::Aqua()
{
	if(!aqua)
	{
    CL_SoundBuffer *sample= new CL_SoundBuffer(new CL_VorbisSoundProvider("music/aqua.ogg", res), true);
    aqua = new CL_SoundBuffer_Session(sample->prepare());
    //aqua->set_looping(true);
  }
	return aqua;
}
void Resources::init()
{
#ifdef WIN32
  res=new CL_ResourceManager("resources.scr", false);
  datapath="";
#else

	try
	{
		res=new CL_ResourceManager("./resources.scr", false);
		datapath="./";
	}
	catch(CL_Error err)
	{
		try
		{
			res=new CL_ResourceManager("/usr/share/auriferous/resources.scr", false);
			datapath="/usr/share/auriferous/";
		}
		catch(CL_Error err)
		{
			res=new CL_ResourceManager("/usr/local/share/auriferous/resources.scr", false);
			datapath="/usr/local/share/auriferous/";
		}
	}
#endif
}
void Resources::load_all()
{
	res->load_all();
}